ReagentCounter = {}
    -------------------------------------------------------------------------------
	local RCTooltip = CreateFrame("GameTooltip","RCTooltip",UIParent,"GameTooltipTemplate")
	RCTooltip:SetOwner(UIParent,"ANCHOR_NONE")
	
	ReagentCounter.reagentForSlot = {}
	local REAGENTS_STRING = 'Reagents:|n(.+)'
	
	local actionBarNames = {'Action', 'BonusAction', 'MultiBarBottomLeft', 'MultiBarBottomRight', 'MultiBarLeft', 'MultiBarRight'}
	local actionButtonListRef = {}
	-------------------------------------------------------------------------------
	local function addFontStringToButton(button)
		button.text = button:CreateFontString(nil, 'OVERLAY', 'NumberFontNormal')
		button.text:SetTextColor(1, 1, 1)
		button.text:SetPoint('BOTTOMRIGHT', button, 'BOTTOMRIGHT', -2, 2)
		button.text:SetDrawLayer('OVERLAY', 2)
		
		table.insert(actionButtonListRef, button:GetName())
	end
	-------------------------------------------------------------------------------
	local function initializeFontStrings()
		-- add fontstring to all buttons
		for k, v in pairs(actionBarNames) do
			for i = 1, NUM_ACTIONBAR_BUTTONS do
				local button = (_G[v..'Button'..i]);
				if(button) then addFontStringToButton(button) end
			end
		end
	end
	-------------------------------------------------------------------------------
	local function initializeReagentsForSlots()
		local lActionSlot = 0;
		ReagentCounter.reagentForSlot = {}
		for lActionSlot = 1, 120 do--NUM_ACTIONBAR_BUTTONS*NUM_ACTIONBAR_PAGES do
			local lActionTexture = GetActionTexture(lActionSlot)
			if lActionTexture then
				RCTooltip:ClearLines()
				RCTooltip:SetAction(lActionSlot)
				for i=1, RCTooltip:NumLines() do
					local tooltipLine = _G['RCTooltipTextLeft'..i]:GetText()
					local reagentStringWithFormatting = string.find(tooltipLine, REAGENTS_STRING)
					if reagentStringWithFormatting then
						local reagentItemName = rText:gsub(reagentStringWithFormatting, '%1'):gsub('|cffff2020(.+)|r', '%1')
						ReagentCounter.reagentForSlot[lActionSlot] = reagentItemName
					end
				end
			end
		end
	end
	-------------------------------------------------------------------------------
	ReagentCounter.getItemCount = function(itemName)
		local ct = 0
		for bag = 0, NUM_BAG_SLOTS do
			for slot = 0, GetContainerNumSlots(bag) do
				local link = GetContainerItemLink(bag, slot)
				if(link) then
					local _,_,name = string.find(link, "^.*%[(.*)%].*$")
					if name == itemName then
						local _,itemCount = GetContainerItemInfo(bag, slot)
						ct = ct + itemCount
					end
				end
			end
		end		
		return ct
	end
	-------------------------------------------------------------------------------
	local function updateFontStrings()
		for k, v in pairs(actionButtonListRef) do
			local bu = _G[v]
			local id = ActionButton_GetPagedID(bu)
			bu.text:SetText(ReagentCounter.reagentForSlot[id] and ReagentCounter.getItemCount(ReagentCounter.resourceList[id]) or '')
		end
	end
	-------------------------------------------------------------------------------
	local function eventHandler(self, event, ...)
		if event == 'PLAYER_LOGIN' then
			initializeFontStrings()
			initializeReagentsForSlots()
			updateFontStrings()
		elseif event == 'ACTIONBAR_SLOT_CHANGED' then
			initializeReagentsForSlots()
			updateFontStrings()
		else
			updateFontStrings()
		end
	end
	-------------------------------------------------------------------------------
	local f = CreateFrame('Frame')
	f:RegisterEvent('PLAYER_LOGIN')
	f:RegisterEvent('BAG_UPDATE')
	f:RegisterEvent('ACTIONBAR_PAGE_CHANGED')
	f:RegisterEvent('ACTIONBAR_SLOT_CHANGED')

	f:SetScript('OnEvent', eventHandler)
	-------------------------------------------------------------------------------
	